hdu 5547

***题意:4*4数独,要求在同一行同一列不能有相同的数字,另外在2*2的小单元里也不能有相同的数字

思路:DFS暴力搜索, 每个位置填1—4,递归回溯,判断是否符合条件,递归到最后一个位置+1则输出答案***

#include<iostream>
#include<cstdio>
#include<cstring>
#include<cstdlib>
#include<cmath>
#include<cctype>
#include<queue>
#include<vector>
#include<algorithm>

using namespace std;
typedef long long LL;
#define N 1001000
#define INF 0x3f3f3f

char maps[10][10];

int judge(int row, int col)
{
    for(int i=0; i<4; i++)
    {
        if(maps[row][i]==maps[row][col]&&i!=col)
            return 0;
    }
    for(int i=0; i<4; i++)
    {
        if(maps[i][col]==maps[row][col]&&i!=row)
            return 0;
    }

    int Row, Col;
    if(row%2==1) Row=row-1;
    else Row=row;

    if(col%2==1) Col=col-1;
    else Col=col;

    for(int i=Row; i<=Row+1; i++)
    {
        for(int j=Col; j<=Col+1; j++)
        {
            if(maps[i][j]==maps[row][col]&&i!=row&&j!=col)
                return 0;
        }
    }
    return 1;
}

void DFS(int t)
{
    if(t==16)
    {
        for(int i=0; i<4; i++)
            puts(maps[i]);
        return ;
    }

    int row=t/4;//行列转换方法,知道如何转换,就可以运用递归去求解了
    int col=t%4;

    if(maps[row][col]==‘*‘)
    {
        for(int i=1; i<=4; i++)
        {
            maps[row][col]=i+‘0‘;
            if(judge(row, col))
                DFS(t+1);

            maps[row][col]=‘*‘;
        }
    }
    else
        DFS(t+1);
}

int main()
{
    int T, cas=1;
    scanf("%d", &T);

    while(T--)
    {
        for(int i=0; i<4; i++)
            scanf("%s", maps[i]);

        printf("Case #%d:\n", cas++);

        DFS(0);
    }
    return 0;
}
时间: 2024-07-28 17:55:25

hdu 5547的相关文章

搜索----hdu 5547

题目链接 http://acm.hdu.edu.cn/showproblem.php?pid=5547 数独,保证每一行每一列都有1,2,3,4 还有4 个2 * 2的小方块儿里也必须是1,2,3,4 输入: 3 **** 2341 4123 3214 *243 *312 *421 *134 *41* **3* 2*41 4*2* 输出: Case #1: 1432 2341 4123 3214 Case #2: 1243 4312 3421 2134 Case #3: 3412 1234 23

随手练——数独 HDU - 5547 坑!坑!坑!

题目链接:HDU-5547 http://acm.hdu.edu.cn/showproblem.php?pid=5547 解题思想:随手练-- 数独 POJ - 2676 (回溯法+DFS) HDU 的这题实在是太坑了,M 数组开成 int 就过不了,改成 char 就过了.对着别人AC的代码,一点点试,到最后才试出来,数组的问题,但是不能理解啊,什么鬼,这也错?? 然后发现题目描述里有一句:Each test case starts with an empty line followed by

HDU 5547 4*4数独 http://acm.split.hdu.edu.cn/status.php

Sample Input 3 **** 2341 4123 3214 *243 *312 *421 *134 *41* **3* 2*41 4*2* Sample Output Case #1: 1432 2341 4123 3214 Case #2: 1243 4312 3421 2134 Case #3: 3412 1234 2341 4123 #include<iostream> #include<cstdio> #include<cstring> #includ

HDU 5547 暴力

Sudoku Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 65535/65535 K (Java/Others)Total Submission(s): 1064    Accepted Submission(s): 362 Problem Description Yi Sima was one of the best counselors of Cao Cao. He likes to play a funny game hi

(hdu)5547 Sudoku (4*4方格的 数独 深搜)

Problem Description Yi Sima was one of the best counselors of Cao Cao. He likes to play a funny game himself. It looks like the modern Sudoku, but smaller. Actually, Yi Sima was playing it different. First of all, he tried to generate a 4×4 board wit

HDU 6203 ping ping ping [LCA,贪心,DFS序,BIT(树状数组)]

题目链接:[http://acm.hdu.edu.cn/showproblem.php?pid=6203] 题意 :给出一棵树,如果(a,b)路径上有坏点,那么(a,b)之间不联通,给出一些不联通的点对,然后判断最少有多少个坏点. 题解 :求每个点对的LCA,然后根据LCA的深度排序.从LCA最深的点对开始,如果a或者b点已经有点被标记了,那么continue,否者标记(a,b)LCA的子树每个顶点加1. #include<Bits/stdc++.h> using namespace std;

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

hdu 1207 汉诺塔II (DP+递推)

汉诺塔II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4529    Accepted Submission(s): 2231 Problem Description 经典的汉诺塔问题经常作为一个递归的经典例题存在.可能有人并不知道汉诺塔问题的典故.汉诺塔来源于印度传说的一个故事,上帝创造世界时作了三根金刚石柱子,在一根柱子上从下往

[hdu 2102]bfs+注意INF

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2102 感觉这个题非常水,结果一直WA,最后发现居然是0x3f3f3f3f不够大导致的--把INF改成INF+INF就过了. #include<bits/stdc++.h> using namespace std; bool vis[2][15][15]; char s[2][15][15]; const int INF=0x3f3f3f3f; const int fx[]={0,0,1,-1};